@echo off

REM Set this to be where the backups will all be stored on the main server
set DEST_BASE=E:\Secure Backups

if "%1" == "" goto _Mega
goto _Single


:_Mega

REM  call %0 COMPUTER SOURCE_DRIVE SOURCE_DIRECTORY DESTINATION_BASE [LOGFILE]
REM    Computer = network name of the computer
REM    Source_Drive = Source drive on computer to backup
REM    Source_Directory = Directory to back up (or empty for everything)
REM    Destination_Base = User's backup directory
REM    Logfile = optional name of the log file, stored in Destination_Base
REM
REM  %DEST_BASE% is the top level directory where the backups all reside.
REM
REM  This backs up the data in the directory specified onto the server in the
REM  location specified.  Make sure that the destination directory exists!  Also,
REM  if you are only backing up a subdirectory, make sure that subdirectory name
REM  exists on the server.
REM
REM  Sample to backup the entire drive and save the log file as backup.log:
REM     call %0 "\\JDoe\C$" "" "John PC"
REM
REM  Sample to backup the Lotus and My Documents directories of a user.
REM  For this to work, you need the "\Lotus\Notes" directory created under
REM  the "John PC" directory, and same goes for 
REM  "\Documents and Settings\john\My Documents"
REM  This example uses different log files -- backup_lotus.txt and backup_doc.txt
REM     call %0 "\\JDoe\C$" "\Lotus\Notes" "John PC" backup_lotus.txt
REM     call %0 "\\JDoe\C$" "\Program Files\Lotus\Notes" "John PC" backup_lotus65.txt
REM     call %0 "\\JDoe\C$" "\Documents and Settings\john\My Documents" "John PC" backup_doc.txt

echo Starting backup ... > backup.txt

REM ----- John's C$ share does not work
REM ----- Backup "My Documents" and "Work" to the "john" directory
REM ----- "john\Documents and Settings\john\My Documents" and "john\Work" must
REM ----- exist before you run the script.
call %0 "\\john\C_Drive" "\Documents and Settings\john\My Documents" john Backup_Doc.txt
call %0 "\\john\C_Drive" "\Work" john Backup_Work.txt

REM ----- Backup Tyler's entire hard drive
REM ----- Exclusions apply; see below
call %0 "\\tyler\C$" "" Tyler Backup.txt

REM ----- Backup Matt's development directory
REM ----- "matt\devel" must already exist
call %0 "\\matt\C$" "\devel" Matt backup_devel.txt

goto _Done


:_Single

set LOGFILE=%4
if "%LOGFILE%" == "" set LOGFILE=backup.log
set LOGFILE=%DEST_BASE%\%3\%LOGFILE%
set LOGFILE=%LOGFILE:"=%

set DIRBASE=%2
set DIRBASE=%DIRBASE:"=%

set FROM=%1%2
set FROM=%FROM:"=%

set TO=%DEST_BASE%\%3%2
set TO=%TO:"=%

REM echo backup_from = [%FROM%]
REM echo backup_to = [%TO%]
REM echo log_file = [%LOGFILE%]

if exist "%FROM%" goto _DestTst
echo Unable to access source %FROM%
echo Unable to access source %FROM% >> backup.txt
goto _Done

:_DestTst
if exist "%TO%" goto _There
mkdir "%TO%"
if exist "%TO%" goto _There
echo Unable to access or create destination %TO%
echo Unable to access or create destination %TO% >> backup.txt
goto _Done

:_There
echo Backing up %FROM%
echo Backing up %FROM% and saving log as %LOGFILE% >> backup.txt

REM ----- This sets exclusions only for situations where the entire
REM ----- hard drive is backed up.  We exclude the windows directory,
REM ----- install files, drivers, temp files, and installed programs.
REM ----- Only set up to 8 exclusions
set EXCLUDE=
if "%DIRBASE%" == "" set EXCLUDE=/E%FROM%\winnt\ /E%FROM%\i386\ /E%FROM%\Drivers\ /E%FROM%\temp\ /E"%FROM%\Program Files\"

REM ----- Also, for everyone, skip any folder that holds temporary
REM ----- files.
REM ----- The total amount of exclusions must be 8 or less
REM ----- because fsync.exe doesn't support more
set EXCLUDE=/E"\Local Settings" /E"\Application Data" %EXCLUDE%

.\fsync.exe "%FROM%" "%TO%" /f /k /D %EXCLUDE% > "%LOGFILE%"

goto _Done

:_Done
